(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     15802,        547]
NotebookOptionsPosition[     13601,        482]
NotebookOutlinePosition[     13960,        498]
CellTagsIndexPosition[     13917,        495]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["\<\
Distance-Matrix Cluster-Analysis Tests

Uses notebook:
Distance-Matrix Cluster Analysis\
\>", "Text"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"For", " ", "graphing", " ", "the", " ", "points"}], " ", 
  "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"graf2d", "[", 
   RowBox[{"pts_", ",", "names_"}], "]"}], " ", ":=", " ", 
  RowBox[{"Graphics", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Point", "[", 
        RowBox[{"#", "[", 
         RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"#", "[", 
          RowBox[{"[", "2", "]"}], "]"}], ",", 
         RowBox[{"#", "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"-", "1"}]}], "}"}]}], "]"}]}], "}"}], "&"}], " ", "/@", 
    " ", 
    RowBox[{"Transpose", "[", 
     RowBox[{"{", 
      RowBox[{"pts", ",", "names"}], "}"}], "]"}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"graf3d", "[", 
   RowBox[{"pts_", ",", "names_"}], "]"}], " ", ":=", " ", 
  RowBox[{"Graphics3D", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Point", "[", 
         RowBox[{"#", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"#", "[", 
           RowBox[{"[", "2", "]"}], "]"}], ",", 
          RowBox[{"#", "[", 
           RowBox[{"[", "1", "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", 
            RowBox[{"-", "1"}]}], "}"}]}], "]"}]}], "}"}], "&"}], " ", "/@", 
     " ", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"pts", ",", "names"}], "}"}], "]"}]}], ",", 
    RowBox[{"SphericalRegion", "\[Rule]", "True"}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"graf2d", "[", "pts_", "]"}], " ", ":=", " ", 
  RowBox[{"graf2d", "[", 
   RowBox[{"pts", ",", 
    RowBox[{"Range", "[", 
     RowBox[{"Length", "[", "pts", "]"}], "]"}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"graf3d", "[", "pts_", "]"}], " ", ":=", " ", 
  RowBox[{"graf3d", "[", 
   RowBox[{"pts", ",", 
    RowBox[{"Range", "[", 
     RowBox[{"Length", "[", "pts", "]"}], "]"}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "One", " ", "of", " ", "the", " ", "example", " ", "distance", " ", 
   "matrices"}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dsmt", " ", "=", " ", 
   RowBox[{
    RowBox[{"DMExample", "[", 
     RowBox[{"\"\<WikiDM\>\"", ",", "\"\<DistMat\>\""}], "]"}], " ", "//", 
    " ", "N"}]}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{"dmnames", " ", "=", " ", 
  RowBox[{"DMExample", "[", 
   RowBox[{"\"\<WikiDM\>\"", ",", "\"\<Names\>\""}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Subsets", " ", "for", " ", "testing", " ", "small", " ", 
   RowBox[{"DM", "'"}], "s"}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dmset", " ", "=", " ", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"dsmt", "[", 
      RowBox[{"[", 
       RowBox[{
        RowBox[{";;", "k"}], ",", 
        RowBox[{";;", "k"}]}], "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "1", ",", 
       RowBox[{"Length", "[", "dsmt", "]"}]}], "}"}]}], "]"}]}], 
  ";"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Distance", "-", 
   RowBox[{"matrix", " ", "fitting"}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"graf2d", "[", 
  RowBox[{"DMFit", "[", 
   RowBox[{"dsmt", ",", "2"}], "]"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"graf2d", "[", 
  RowBox[{"DMMDS", "[", 
   RowBox[{"dsmt", ",", "2"}], "]"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"K", "-", 
    RowBox[{"medoids", " ", 
     RowBox[{"test", " ", "--"}], " ", "what", " ", "centroids"}]}], ",", " ",
    "members", ",", " ", "assignments"}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"BlockRandom", "[", 
  RowBox[{
   RowBox[{"SeedRandom", "[", "\"\<Phylogeny\>\"", "]"}], ";", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"DMKMedoids", "[", 
      RowBox[{"dsmt", ",", 
       RowBox[{"RandomIndices", "[", 
        RowBox[{
         RowBox[{"Length", "[", "dsmt", "]"}], ",", "2"}], "]"}]}], "]"}], 
     ",", 
     RowBox[{"{", "10", "}"}]}], "]"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Neighbor", " ", "joining"}], " ", "*)"}]], "Input"],

Cell[BoxData["NJTypes"], "Input"],

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"NeighborJoin", "[", 
      RowBox[{"dmi", ",", "#"}], "]"}], "&"}], " ", "/@", " ", "NJTypes"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"dmi", ",", "dmset"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"treenjs", " ", "=", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"NeighborJoin", "[", 
      RowBox[{"dsmt", ",", "#"}], "]"}], "&"}], " ", "/@", " ", "NJTypes"}]}],
   ";"}]], "Input"],

Cell[BoxData[
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"NJTypes", "[", 
      RowBox[{"[", "k", "]"}], "]"}], "]"}], ";", 
    RowBox[{"Print", "[", 
     RowBox[{"NJDumpTree", "[", 
      RowBox[{
       RowBox[{"treenjs", "[", 
        RowBox[{"[", "k", "]"}], "]"}], ",", "dmnames"}], "]"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", 
     RowBox[{"Length", "[", "NJTypes", "]"}]}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"Improve", " ", "the", " ", "neighbor"}], "-", 
   RowBox[{"joining", " ", "trees", " ", "with", " ", "Fitch"}], "-", 
   RowBox[{"Margoliash", " ", "fitting"}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"fmnjtrees", ",", " ", "fmnjdists"}], "}"}], " ", "=", " ", 
  RowBox[{"Transpose", "[", 
   RowBox[{"NJtoFMTree", " ", "/@", " ", "treenjs"}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"fmnjdstfits", ",", "fmnjerrs"}], "}"}], " ", "=", " ", 
  RowBox[{"Transpose", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"FMDMFit", "[", 
      RowBox[{"#", ",", "dsmt"}], "]"}], "&"}], " ", "/@", " ", "fmnjtrees"}],
    "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"FMDMCheckRMS", "[", 
      RowBox[{
       RowBox[{"fmnjtrees", "[", 
        RowBox[{"[", "k", "]"}], "]"}], ",", 
       RowBox[{"fmnjdists", "[", 
        RowBox[{"[", "k", "]"}], "]"}], ",", "dsmt"}], "]"}], ",", 
     RowBox[{"fmnjerrs", "[", 
      RowBox[{"[", "k", "]"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", 
     RowBox[{"Length", "[", "NJTypes", "]"}]}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Random", " ", "FM", " ", 
   RowBox[{"trees", " ", "--"}], " ", "notice", " ", "that", " ", "their", 
   " ", "errors", " ", "are", " ", "rather", " ", "similar"}], " ", 
  "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"BlockRandom", "[", 
  RowBox[{
   RowBox[{"SeedRandom", "[", "\"\<Phylogeny\>\"", "]"}], ";", " ", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"FMDMFit", "[", 
       RowBox[{
        RowBox[{"FMRandomTree", "[", 
         RowBox[{"Length", "[", "dsmt", "]"}], "]"}], ",", "dsmt"}], "]"}], 
      "[", 
      RowBox[{"[", "2", "]"}], "]"}], ",", 
     RowBox[{"{", "10", "}"}]}], "]"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Incremental", " ", "improvement"}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"treefminc", " ", "=", " ", 
  RowBox[{"FMIncremental", "[", "dsmt", "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Link", "-", 
   RowBox[{
   "flipping", " ", "improvement", " ", "of", " ", "random", " ", "trees"}]}],
   " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"treefmrfs", " ", "=", " ", 
  RowBox[{"BlockRandom", "[", 
   RowBox[{
    RowBox[{"SeedRandom", "[", "\"\<Phylogeny\>\"", "]"}], ";", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"FMImproveByFlipping", "[", 
       RowBox[{
        RowBox[{"FMRandomTree", "[", 
         RowBox[{"Length", "[", "dsmt", "]"}], "]"}], ",", "dsmt"}], "]"}], 
      ",", 
      RowBox[{"{", "10", "}"}]}], "]"}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"Mma", " ", "graph", " ", 
    RowBox[{"objects", " ", "--"}], " ", "NJ"}], ",", " ", 
   RowBox[{"FM", " ", "trees"}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"NJMakeMmaGraph", "[", 
  RowBox[{"treenjs", "[", 
   RowBox[{"[", "3", "]"}], "]"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"FMMakeMmaGraph", "[", 
  RowBox[{
   RowBox[{"fmnjtrees", "[", 
    RowBox[{"[", "3", "]"}], "]"}], ",", 
   RowBox[{"fmnjdists", "[", 
    RowBox[{"[", "3", "]"}], "]"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"FMMakeMmaGraph", "[", 
  RowBox[{
   RowBox[{"treefminc", "[", 
    RowBox[{"[", "1", "]"}], "]"}], ",", 
   RowBox[{"treefminc", "[", 
    RowBox[{"[", 
     RowBox[{"2", ",", "1"}], "]"}], "]"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Small", " ", "trees"}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"NeighborJoin", "[", 
  RowBox[{
   RowBox[{"dmset", "[", 
    RowBox[{"[", "2", "]"}], "]"}], ",", "\"\<NeiSaitou\>\""}], 
  "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"NJtoFMTree", "[", "%", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"FMDMFit", "[", 
  RowBox[{
   RowBox[{"%", "[", 
    RowBox[{"[", "1", "]"}], "]"}], ",", 
   RowBox[{"dmset", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"FMIncremental", "[", 
  RowBox[{"dmset", "[", 
   RowBox[{"[", "2", "]"}], "]"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"FMImproveByFlipping", "[", 
  RowBox[{
   RowBox[{"%", "[", 
    RowBox[{"[", "1", "]"}], "]"}], ",", 
   RowBox[{"dmset", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"NeighborJoin", "[", 
  RowBox[{
   RowBox[{"dmset", "[", 
    RowBox[{"[", "3", "]"}], "]"}], ",", "\"\<NeiSaitou\>\""}], 
  "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"NJtoFMTree", "[", "%", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"FMDMFit", "[", 
  RowBox[{
   RowBox[{"%", "[", 
    RowBox[{"[", "1", "]"}], "]"}], ",", 
   RowBox[{"dmset", "[", 
    RowBox[{"[", "3", "]"}], "]"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"FMIncremental", "[", 
  RowBox[{"dmset", "[", 
   RowBox[{"[", "3", "]"}], "]"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"FMImproveByFlipping", "[", 
  RowBox[{
   RowBox[{"%", "[", 
    RowBox[{"[", "1", "]"}], "]"}], ",", 
   RowBox[{"dmset", "[", 
    RowBox[{"[", "3", "]"}], "]"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{
   "FMCycles", " ", "counts", " ", "how", " ", "many", " ", "cycles", " ", 
    "there", " ", "are", " ", "in", " ", "a", " ", 
    RowBox[{"graph", " ", "--"}], " ", "supposed", " ", "to", " ", "be", " ", 
    "none", " ", "for", " ", "the", " ", "phylogeny", " ", "trees"}], ",", 
   " ", 
   RowBox[{"one", " ", "for", " ", "benzene", " ", "molecules"}], ",", " ", 
   RowBox[{
   "and", " ", "four", " ", "for", " ", "the", " ", "famous", " ", "bridges", 
    " ", "of", " ", 
    RowBox[{"Koenigsberg", "."}]}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"benzene", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "7"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "8"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "9"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "10"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"5", ",", "11"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"6", ",", "12"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"7", ",", "8"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"8", ",", "9"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"9", ",", "10"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"10", ",", "11"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"11", ",", "12"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"12", ",", "7"}], "}"}]}], "}"}]}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{"FMCycles", "[", "benzene", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"koenigsberg", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "4"}], "}"}]}], "}"}]}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{"FMCycles", "[", "koenigsberg", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"FMCycles", " ", "/@", " ", "fmnjtrees"}]], "Input"]
},
WindowSize->{808, 695},
WindowMargins->{{Automatic, 124}, {Automatic, 7}},
FrontEndVersion->"11.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (September \
21, 2016)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 111, 5, 87, "Text"],
Cell[672, 27, 123, 3, 32, "Input"],
Cell[798, 32, 766, 24, 54, "Input"],
Cell[1567, 58, 860, 26, 75, "Input"],
Cell[2430, 86, 227, 6, 32, "Input"],
Cell[2660, 94, 227, 6, 32, "Input"],
Cell[2890, 102, 156, 4, 32, "Input"],
Cell[3049, 108, 211, 6, 32, "Input"],
Cell[3263, 116, 150, 3, 32, "Input"],
Cell[3416, 121, 157, 3, 32, "Input"],
Cell[3576, 126, 385, 13, 32, "Input"],
Cell[3964, 141, 126, 3, 32, "Input"],
Cell[4093, 146, 118, 3, 32, "Input"],
Cell[4214, 151, 118, 3, 32, "Input"],
Cell[4335, 156, 240, 6, 32, "Input"],
Cell[4578, 164, 419, 12, 54, "Input"],
Cell[5000, 178, 97, 2, 32, "Input"],
Cell[5100, 182, 33, 0, 32, "Input"],
Cell[5136, 184, 272, 9, 32, "Input"],
Cell[5411, 195, 219, 7, 32, "Input"],
Cell[5633, 204, 466, 14, 54, "Input"],
Cell[6102, 220, 243, 5, 32, "Input"],
Cell[6348, 227, 213, 5, 32, "Input"],
Cell[6564, 234, 293, 9, 32, "Input"],
Cell[6860, 245, 508, 15, 54, "Input"],
Cell[7371, 262, 236, 5, 32, "Input"],
Cell[7610, 269, 453, 13, 54, "Input"],
Cell[8066, 284, 104, 2, 32, "Input"],
Cell[8173, 288, 110, 2, 32, "Input"],
Cell[8286, 292, 175, 5, 32, "Input"],
Cell[8464, 299, 448, 12, 54, "Input"],
Cell[8915, 313, 201, 5, 32, "Input"],
Cell[9119, 320, 125, 3, 32, "Input"],
Cell[9247, 325, 214, 6, 32, "Input"],
Cell[9464, 333, 240, 7, 32, "Input"],
Cell[9707, 342, 92, 2, 32, "Input"],
Cell[9802, 346, 165, 5, 32, "Input"],
Cell[9970, 353, 63, 1, 32, "Input"],
Cell[10036, 356, 195, 6, 32, "Input"],
Cell[10234, 364, 122, 3, 32, "Input"],
Cell[10359, 369, 207, 6, 32, "Input"],
Cell[10569, 377, 165, 5, 32, "Input"],
Cell[10737, 384, 63, 1, 32, "Input"],
Cell[10803, 387, 195, 6, 32, "Input"],
Cell[11001, 395, 122, 3, 32, "Input"],
Cell[11126, 400, 207, 6, 32, "Input"],
Cell[11336, 408, 599, 13, 75, "Input"],
Cell[11938, 423, 877, 28, 54, "Input"],
Cell[12818, 453, 67, 1, 32, "Input"],
Cell[12888, 456, 557, 18, 32, "Input"],
Cell[13448, 476, 71, 1, 32, "Input"],
Cell[13522, 479, 75, 1, 32, "Input"]
}
]
*)

